(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('bootstrap-datepicker'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', 'bootstrap-datepicker', '@angular/common'], factory) :
	(factory((global['ngq-datepicker'] = {}),global.ng.core,global.ng.forms,null,global.ng.common));
}(this, (function (exports,core,forms,bootstrapDatepicker,common) { 'use strict';

var BASE_OPTION = { autoclose: true, format: 'dd/mm/yyyy' };
var THAI_OPTION = Object.assign({}, BASE_OPTION, { language: 'th-TH' });
var NGQ_DATETIME_VALUE_ACCESSOR = {
    provide: forms.NG_VALUE_ACCESSOR,
    useExisting: core.forwardRef(function () { return NgqDatepickerComponent; }),
    multi: true
};
var NgqDatepickerComponent = /** @class */ (function () {
    function NgqDatepickerComponent() {
        this.propagateChange = function (_) { };
        this.onTouched = function () { };
    }
    NgqDatepickerComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        this._datepicker = jQuery(this.input.nativeElement).datepicker(THAI_OPTION);
        this._datepicker.datepicker().on('changeDate', function (e) {
            _this._date = e.date;
            _this.propagateChange(_this._date);
        });
        this._datepicker.datepicker('update', this._date);
        this._datepicker.prop('disabled', this._isDisabled);
    };
    NgqDatepickerComponent.prototype.writeValue = function (obj) {
        this._date = obj;
    };
    NgqDatepickerComponent.prototype.registerOnChange = function (fn) {
        this.propagateChange = fn;
    };
    NgqDatepickerComponent.prototype.registerOnTouched = function (fn) { };
    NgqDatepickerComponent.prototype.setDisabledState = function (isDisabled) {
        this._isDisabled = isDisabled;
    };
    return NgqDatepickerComponent;
}());
NgqDatepickerComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'ngq-datepicker',
                template: "<div *ngIf=\"!hideIcon\" class=\"input-group\">\n  <input #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\">\n  <div class=\"input-group-addon\" (click)=\"this._datepicker.datepicker('show')\">\n    <span class=\"glyphicon glyphicon-calendar\"></span>\n  </div>\n</div>\n<input *ngIf=\"hideIcon\" #input type=\"text\" [attr.class]=\"class\" [attr.id]=\"id\" [attr.placeholder]=\"placeholder\">\n",
                styles: [":host{outline:0}"],
                providers: [NGQ_DATETIME_VALUE_ACCESSOR]
            },] },
];
NgqDatepickerComponent.ctorParameters = function () { return []; };
NgqDatepickerComponent.propDecorators = {
    "hideIcon": [{ type: core.Input },],
    "id": [{ type: core.Input },],
    "class": [{ type: core.Input },],
    "placeholder": [{ type: core.Input },],
    "input": [{ type: core.ViewChild, args: ['input',] },],
    "onTouched": [{ type: core.HostListener, args: ['blur',] },],
};
var NgqDatepickerModule = /** @class */ (function () {
    function NgqDatepickerModule() {
    }
    return NgqDatepickerModule;
}());
NgqDatepickerModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [common.CommonModule],
                declarations: [NgqDatepickerComponent],
                exports: [NgqDatepickerComponent]
            },] },
];
NgqDatepickerModule.ctorParameters = function () { return []; };

exports.NgqDatepickerModule = NgqDatepickerModule;
exports.ɵa = NgqDatepickerComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngq-datepicker.umd.js.map
